/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube    ---   Limitations and specifcities:    * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Preset import and export from/to file is a server only feature.   * Device set focus is a GUI only feature.   * The following channels are not implemented (status 501 is returned): ATV and DATV demodulators, Channel Analyzer NG, LoRa demodulator   * The device settings and report structures contains only the sub-structure corresponding to the device type. The DeviceSettings and DeviceReport structures documented here shows all of them but only one will be or should be present at a time   * The channel settings and report structures contains only the sub-structure corresponding to the channel type. The ChannelSettings and ChannelReport structures documented here shows all of them but only one will be or should be present at a time    --- 
 *
 * OpenAPI spec version: 7.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

/*
 * SWGAPRSSettings.h
 *
 * APRS settings
 */

#ifndef SWGAPRSSettings_H_
#define SWGAPRSSettings_H_

#include <QJsonObject>


#include "SWGRollupState.h"
#include <QList>
#include <QString>

#include "SWGObject.h"
#include "export.h"

namespace SWGSDRangel {

class SWG_API SWGAPRSSettings: public SWGObject {
public:
    SWGAPRSSettings();
    SWGAPRSSettings(QString* json);
    virtual ~SWGAPRSSettings();
    void init();
    void cleanup();

    virtual QString asJson () override;
    virtual QJsonObject* asJsonObject() override;
    virtual void fromJsonObject(QJsonObject &json) override;
    virtual SWGAPRSSettings* fromJson(QString &jsonString) override;

    QString* getIgateServer();
    void setIgateServer(QString* igate_server);

    qint32 getIgatePort();
    void setIgatePort(qint32 igate_port);

    QString* getIgateCallsign();
    void setIgateCallsign(QString* igate_callsign);

    QString* getIgatePasscode();
    void setIgatePasscode(QString* igate_passcode);

    QString* getIgateFilter();
    void setIgateFilter(QString* igate_filter);

    qint32 getIgateEnabled();
    void setIgateEnabled(qint32 igate_enabled);

    QString* getTitle();
    void setTitle(QString* title);

    qint32 getRgbColor();
    void setRgbColor(qint32 rgb_color);

    qint32 getUseReverseApi();
    void setUseReverseApi(qint32 use_reverse_api);

    QString* getReverseApiAddress();
    void setReverseApiAddress(QString* reverse_api_address);

    qint32 getReverseApiPort();
    void setReverseApiPort(qint32 reverse_api_port);

    qint32 getReverseApiFeatureSetIndex();
    void setReverseApiFeatureSetIndex(qint32 reverse_api_feature_set_index);

    qint32 getReverseApiFeatureIndex();
    void setReverseApiFeatureIndex(qint32 reverse_api_feature_index);

    SWGRollupState* getRollupState();
    void setRollupState(SWGRollupState* rollup_state);

    QList<qint32>* getPacketsTableColumnIndexes();
    void setPacketsTableColumnIndexes(QList<qint32>* packets_table_column_indexes);

    QList<qint32>* getPacketsTableColumnSizes();
    void setPacketsTableColumnSizes(QList<qint32>* packets_table_column_sizes);

    QList<qint32>* getWeatherTableColumnIndexes();
    void setWeatherTableColumnIndexes(QList<qint32>* weather_table_column_indexes);

    QList<qint32>* getWeatherTableColumnSizes();
    void setWeatherTableColumnSizes(QList<qint32>* weather_table_column_sizes);

    QList<qint32>* getStatusTableColumnIndexes();
    void setStatusTableColumnIndexes(QList<qint32>* status_table_column_indexes);

    QList<qint32>* getStatusTableColumnSizes();
    void setStatusTableColumnSizes(QList<qint32>* status_table_column_sizes);

    QList<qint32>* getMessagesTableColumnIndexes();
    void setMessagesTableColumnIndexes(QList<qint32>* messages_table_column_indexes);

    QList<qint32>* getMessagesTableColumnSizes();
    void setMessagesTableColumnSizes(QList<qint32>* messages_table_column_sizes);

    QList<qint32>* getTelemetryTableColumnIndexes();
    void setTelemetryTableColumnIndexes(QList<qint32>* telemetry_table_column_indexes);

    QList<qint32>* getTelemetryTableColumnSizes();
    void setTelemetryTableColumnSizes(QList<qint32>* telemetry_table_column_sizes);

    QList<qint32>* getMotionTableColumnIndexes();
    void setMotionTableColumnIndexes(QList<qint32>* motion_table_column_indexes);

    QList<qint32>* getMotionTableColumnSizes();
    void setMotionTableColumnSizes(QList<qint32>* motion_table_column_sizes);


    virtual bool isSet() override;

private:
    QString* igate_server;
    bool m_igate_server_isSet;

    qint32 igate_port;
    bool m_igate_port_isSet;

    QString* igate_callsign;
    bool m_igate_callsign_isSet;

    QString* igate_passcode;
    bool m_igate_passcode_isSet;

    QString* igate_filter;
    bool m_igate_filter_isSet;

    qint32 igate_enabled;
    bool m_igate_enabled_isSet;

    QString* title;
    bool m_title_isSet;

    qint32 rgb_color;
    bool m_rgb_color_isSet;

    qint32 use_reverse_api;
    bool m_use_reverse_api_isSet;

    QString* reverse_api_address;
    bool m_reverse_api_address_isSet;

    qint32 reverse_api_port;
    bool m_reverse_api_port_isSet;

    qint32 reverse_api_feature_set_index;
    bool m_reverse_api_feature_set_index_isSet;

    qint32 reverse_api_feature_index;
    bool m_reverse_api_feature_index_isSet;

    SWGRollupState* rollup_state;
    bool m_rollup_state_isSet;

    QList<qint32>* packets_table_column_indexes;
    bool m_packets_table_column_indexes_isSet;

    QList<qint32>* packets_table_column_sizes;
    bool m_packets_table_column_sizes_isSet;

    QList<qint32>* weather_table_column_indexes;
    bool m_weather_table_column_indexes_isSet;

    QList<qint32>* weather_table_column_sizes;
    bool m_weather_table_column_sizes_isSet;

    QList<qint32>* status_table_column_indexes;
    bool m_status_table_column_indexes_isSet;

    QList<qint32>* status_table_column_sizes;
    bool m_status_table_column_sizes_isSet;

    QList<qint32>* messages_table_column_indexes;
    bool m_messages_table_column_indexes_isSet;

    QList<qint32>* messages_table_column_sizes;
    bool m_messages_table_column_sizes_isSet;

    QList<qint32>* telemetry_table_column_indexes;
    bool m_telemetry_table_column_indexes_isSet;

    QList<qint32>* telemetry_table_column_sizes;
    bool m_telemetry_table_column_sizes_isSet;

    QList<qint32>* motion_table_column_indexes;
    bool m_motion_table_column_indexes_isSet;

    QList<qint32>* motion_table_column_sizes;
    bool m_motion_table_column_sizes_isSet;

};

}

#endif /* SWGAPRSSettings_H_ */
