/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube    ---   Limitations and specifcities:    * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Preset import and export from/to file is a server only feature.   * Device set focus is a GUI only feature.   * The following channels are not implemented (status 501 is returned): ATV and DATV demodulators, Channel Analyzer NG, LoRa demodulator   * The device settings and report structures contains only the sub-structure corresponding to the device type. The DeviceSettings and DeviceReport structures documented here shows all of them but only one will be or should be present at a time   * The channel settings and report structures contains only the sub-structure corresponding to the channel type. The ChannelSettings and ChannelReport structures documented here shows all of them but only one will be or should be present at a time    --- 
 *
 * OpenAPI spec version: 7.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

/*
 * SWGAPTDemodActions_aos.h
 *
 * Acquisition of signal
 */

#ifndef SWGAPTDemodActions_aos_H_
#define SWGAPTDemodActions_aos_H_

#include <QJsonObject>


#include <QString>

#include "SWGObject.h"
#include "export.h"

namespace SWGSDRangel {

class SWG_API SWGAPTDemodActions_aos: public SWGObject {
public:
    SWGAPTDemodActions_aos();
    SWGAPTDemodActions_aos(QString* json);
    virtual ~SWGAPTDemodActions_aos();
    void init();
    void cleanup();

    virtual QString asJson () override;
    virtual QJsonObject* asJsonObject() override;
    virtual void fromJsonObject(QJsonObject &json) override;
    virtual SWGAPTDemodActions_aos* fromJson(QString &jsonString) override;

    QString* getSatelliteName();
    void setSatelliteName(QString* satellite_name);

    qint32 getNorthToSouthPass();
    void setNorthToSouthPass(qint32 north_to_south_pass);

    QString* getTle();
    void setTle(QString* tle);

    QString* getDateTime();
    void setDateTime(QString* date_time);


    virtual bool isSet() override;

private:
    QString* satellite_name;
    bool m_satellite_name_isSet;

    qint32 north_to_south_pass;
    bool m_north_to_south_pass_isSet;

    QString* tle;
    bool m_tle_isSet;

    QString* date_time;
    bool m_date_time_isSet;

};

}

#endif /* SWGAPTDemodActions_aos_H_ */
