/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube    ---   Limitations and specifcities:    * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Preset import and export from/to file is a server only feature.   * Device set focus is a GUI only feature.   * The following channels are not implemented (status 501 is returned): ATV and DATV demodulators, Channel Analyzer NG, LoRa demodulator   * The device settings and report structures contains only the sub-structure corresponding to the device type. The DeviceSettings and DeviceReport structures documented here shows all of them but only one will be or should be present at a time   * The channel settings and report structures contains only the sub-structure corresponding to the channel type. The ChannelSettings and ChannelReport structures documented here shows all of them but only one will be or should be present at a time    --- 
 *
 * OpenAPI spec version: 7.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

/*
 * SWGCapture.h
 *
 * 
 */

#ifndef SWGCapture_H_
#define SWGCapture_H_

#include <QJsonObject>



#include "SWGObject.h"
#include "export.h"

namespace SWGSDRangel {

class SWG_API SWGCapture: public SWGObject {
public:
    SWGCapture();
    SWGCapture(QString* json);
    virtual ~SWGCapture();
    void init();
    void cleanup();

    virtual QString asJson () override;
    virtual QJsonObject* asJsonObject() override;
    virtual void fromJsonObject(QJsonObject &json) override;
    virtual SWGCapture* fromJson(QString &jsonString) override;

    qint64 getTsms();
    void setTsms(qint64 tsms);

    qint64 getCenterFrequency();
    void setCenterFrequency(qint64 center_frequency);

    qint32 getSampleRate();
    void setSampleRate(qint32 sample_rate);

    qint64 getSampleStart();
    void setSampleStart(qint64 sample_start);

    qint64 getLength();
    void setLength(qint64 length);

    qint64 getCumulativeTime();
    void setCumulativeTime(qint64 cumulative_time);


    virtual bool isSet() override;

private:
    qint64 tsms;
    bool m_tsms_isSet;

    qint64 center_frequency;
    bool m_center_frequency_isSet;

    qint32 sample_rate;
    bool m_sample_rate_isSet;

    qint64 sample_start;
    bool m_sample_start_isSet;

    qint64 length;
    bool m_length_isSet;

    qint64 cumulative_time;
    bool m_cumulative_time_isSet;

};

}

#endif /* SWGCapture_H_ */
