/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube    ---   Limitations and specifcities:    * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Preset import and export from/to file is a server only feature.   * Device set focus is a GUI only feature.   * The following channels are not implemented (status 501 is returned): ATV and DATV demodulators, Channel Analyzer NG, LoRa demodulator   * The device settings and report structures contains only the sub-structure corresponding to the device type. The DeviceSettings and DeviceReport structures documented here shows all of them but only one will be or should be present at a time   * The channel settings and report structures contains only the sub-structure corresponding to the channel type. The ChannelSettings and ChannelReport structures documented here shows all of them but only one will be or should be present at a time    --- 
 *
 * OpenAPI spec version: 7.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

/*
 * SWGUDPSinkReport.h
 *
 * UDPSink
 */

#ifndef SWGUDPSinkReport_H_
#define SWGUDPSinkReport_H_

#include <QJsonObject>



#include "SWGObject.h"
#include "export.h"

namespace SWGSDRangel {

class SWG_API SWGUDPSinkReport: public SWGObject {
public:
    SWGUDPSinkReport();
    SWGUDPSinkReport(QString* json);
    virtual ~SWGUDPSinkReport();
    void init();
    void cleanup();

    virtual QString asJson () override;
    virtual QJsonObject* asJsonObject() override;
    virtual void fromJsonObject(QJsonObject &json) override;
    virtual SWGUDPSinkReport* fromJson(QString &jsonString) override;

    float getOutputPowerDb();
    void setOutputPowerDb(float output_power_db);

    float getChannelPowerDb();
    void setChannelPowerDb(float channel_power_db);

    qint32 getSquelch();
    void setSquelch(qint32 squelch);

    qint32 getInputSampleRate();
    void setInputSampleRate(qint32 input_sample_rate);


    virtual bool isSet() override;

private:
    float output_power_db;
    bool m_output_power_db_isSet;

    float channel_power_db;
    bool m_channel_power_db_isSet;

    qint32 squelch;
    bool m_squelch_isSet;

    qint32 input_sample_rate;
    bool m_input_sample_rate_isSet;

};

}

#endif /* SWGUDPSinkReport_H_ */
